MODULE MUserFunc

IMPLICIT NONE

DOUBLE PRECISION, PRIVATE :: h, t0, b, eta
COMMON /MEULER_GLOBS/ h, t0, b, eta

CONTAINS

! This function computes, whether (y, t) is in the domain of f
LOGICAL FUNCTION IsInDomain_f(y, t)
   DOUBLE PRECISION, INTENT(IN) :: y, t

   IF (t0 .LE. b) THEN
      IsInDomain_f = ((t0 .LE. t) .AND. (t .LE. b))
   ELSE
      ! here is (t0 .GT. b)
      ! i.e. (b .LT. t0)
      IsInDomain_f = ((b .LE. t) .AND. (t .LE. t0))
   END IF
   RETURN
END FUNCTION IsInDomain_f

! This function is the example of the preprint.
! If (y, t) is out of domain,  OutOFDomain is set to .TRUE.!
DOUBLE PRECISION FUNCTION f(OutOfDomain, y, t)
   LOGICAL, INTENT(OUT) :: OutOfDomain
   DOUBLE PRECISION, INTENT(IN) :: y, t
   
   IF (.NOT. IsInDomain_f(y, t)) THEN
      OutOfDomain = .TRUE.
      f = DBLE(0)
      RETURN
   END IF

   OutOfDomain = .FALSE.
   f = DSIN(DBLE(1) / (DBLE(1) - t))
   RETURN
END FUNCTION f

END MODULE MUserFunc
